-- !! Mob Arena v.10 !!
-- Coded by KirConjurer 
-- TODO:
-- Demon skills: ???
-- Wasp - hive control skills (fear+force attack)
-- Necromancer attack animation
-- Trap-placing skills
-- 767-783 904+ good sounds
-- Fix server-side projectile ghosts glitch
-- recode spawning alghoritm (using metatable)

--[[

-- v4 changelog:
-- improved melee attacking
-- Necromancer's Cold Touch now deals 10 damage (was 20)
-- Added distance check to Necromancer's Cold Touch (max 375)
-- Necromancer's Deep Freeze now deals 10-20 damage (was 10-30)
-- also freeze time was reduced to 2-3 seconds (was 2-4)
-- Bear's Bash active radius increased from 70 to 80
-- Bear's Bash damage increased from 1 to 8
-- Gargoyle's Power Shot damage reduced from 20-40 to 10-20
-- Added distance check to Spider's Poison (max 220)
-- Removed poison immunity on Necromancer, Gargoyle
-- Shade's attack time increased to 18
-- Shade got a new skill: Jump

-- v5 changelog:
-- Added Archmage!
-- Offensive skills and custom attacks now cancel Invulnerability
-- Necromancer now has casting animation
-- There is a pick message now

-- v6 changelog:
-- Added Scorpion!
-- Decreased Bear's attack timeout from 50 to 48
-- Fixed Archmage and Necromancer Low-HP AI
-- Slightly nerfed Spider's Poison
-- Spider got a new skill: Spiderlings

-- v7 changelog:
-- Mobs now are unable to use skills while stunned/frozen
-- Added Dryad!
-- Added Zombie!
-- Added Wasp!
-- Scorpion's passive now ignores DAMAGE_POISON
-- Necromancer's Deep Freeze radius increased from 160 to 200

-- v8 changelog:
-- Added Ogre!
-- Added Skeleton!
-- Target search range increased from 4 to 5
-- Wasps spawned from Hive now have 10 health (instead of 15)
-- Wolf's vampirism coeff increased to 50%
-- Wolf now divides damage taken with his companion
-- Scorpion's passive now also regenerates health
-- Scorpion's passive now ignores fire damage
-- Fixed health bar bug with summoned mobs
-- Troll's Hook now flies faster
-- Bear's Lick skill replaced with passive regeneration
-- Enchant #19 (ENCHANT_PROTECT_FROM_MAGIC) now used as Magic Immunity
-- Fixed critical bug in vector calculations

-- v9 changelog:
-- Skeleton's health lowered from 80 to 60
-- Skeleton's first skill regen effect lowered from 15 hp/sec to 12 hp/sec
-- Fixed Skeleton auto-blocking any projectiles
-- Skeleton's second skill was removed (temporarily)
-- Archmage's fireball damage decreased from 32 to 5
-- Archmage's second skill now grants invulnerability for 1 second
-- There is now a "Death View" for 1 second
-- Wasp summon limit reduced from 5 to 3
-- Fixed Troll's attack delay (according to monster.bin)
-- Bear's health lowered from 120 to 110
-- Bear's extra regeneration won't work if within 2 seconds of last attack
-- Increased flight speed of Troll's Harpoon (renamed)

-- v10 changelog:
-- Increased attack delay of those monsters: Shade, Gargoyle, Flyer, Spider, Wolf, Imp
-- Troll's Harpoon now can pull victims through windows
-- Fixed some AI related problems; script performance are bit smoothier now
-- Ability cooldowns are now FPS aware
-- Moved some of skill-related monster code to separate file 
-- Ogre's Magic Resistance lasts longer (5 seconds)
-- Creature movement partially redone (more Nox-style)
-- Speed multipliers has been modified due to new movement
-- Necromancer's Deep Freeze now has casting time of 0.5 seconds and can be interrupted
-- Altered Statue's damage mechanics to fix Immolation exploit
-- Archmage's Restoration heal effect buffed from 15 to 20
-- Necromancer got a new skill: Raise Zombie
-- Hive Wasps health increased from 10 to 12
-- Flyer's Rapid Fire is now can be interrupted by stun/fear/freeze/confuse
-- Added Urchin Shaman!
-- Imp's Clone now produces 5 clones (instead of 4), but they don't shoot at their own

По - русски:
http://forum.noxworld.ru/modding/controllable-mob-arena-(unimod)/

]]--

dofile(".\\scripts\\unitUtil.lua")
dofile(".\\scripts\\ma-extra.lua")
dofile(".\\scripts\\ma-bots.lua")

local function atPlayerMouse(plr) -- modified atMouse from autoexec, returns only alive mobs
 local x,y = playerMouse(plr)
 local obj = nil
 local fn = function(p) if (unitHP(p) > 0 and unitIsMonster(p)) then obj = p end end
 local d = 5
 unitGetAround(fn, x-d, y-d, x+d, y+d)
 return obj
end

local function mobNoRunaway(unit)
    local uc = getPtrPtr(unit, 0x2EC)
    local fl = getPtrInt(uc, 0x5A0)
    if (bitAnd(fl, 0x20) == 0x20) then
        setPtrInt(uc, 0x5A0, bitXor(fl, 0x20)) -- CAN_CAST_SPELLS
    end
    setPtrFloat(uc, 0x54C, 0) -- flee distance
    setPtrFloat(uc, 0x538, 0) -- health coeff
    return unit
end

function mobCheckFrustrated(unit) -- look 0x544566
    local uc = getPtrPtr(unit, 0x2EC)
    local fl = getPtrInt(uc, 0x5A0)
    if (bitAnd(fl, 0x200000) == 0x200000) then
        setPtrInt(uc, 0x5A0, bitXor(fl, 0x200000)) -- FRUSTRATED
        --setPtrByte(uc, 0x11C, 0) -- travelStatus?
        --setPtrInt(uc, 0x21C, 0)
        --setPtrInt(uc, 0x8, 0) -- path itself
        unitActionPop(unit)
    end
    return unit
end

local function mobNoAutoshield(unit)
    local uc = getPtrPtr(unit, 0x2EC)
    local fl = getPtrInt(uc, 0x5A0)
    if (bitAnd(fl, 4) == 4) then
        setPtrInt(uc, 0x5A0, bitXor(fl, 4)) -- CAN_BLOCK
    end
    return unit
end
    
local function fxMagicResist(x, y)
    local rx = math.random(-20, 20)
    local ry = math.random(-20, 20)
    x = math.abs(x + rx)
    y = math.abs(y + ry)
    --unitDecay(createObject("MagicSpark", x, y), 2)
    netPointFx(0x87, x, y)
    soundMake(560, x, y) -- BeholderMove
    return true
end

function isMagicVulnerable(targ)
    if (unitTestBuff(targ, 23) or unitTestBuff(targ, 19)) then return false end
    return true -- check ENCHANT_INVULNERABLE and ENCHANT_PROTECT_FROM_MAGIC (Reserved by Westwood, now it's magic immunity)
end

local mobPlayerMap = {} -- for observer trap, thanks to Dio

local function removeMob(mob, plr)
    unitDecay(mob, 20) -- 1 sec
    if objectExists(plr) then
        local s = createObject("ReleasedSoul", unitPos(mob)) -- "HandBrazier"
        playerLook(plr, s) -- death vision
        setTimeout(function() unitDecay(s, 1) end, 30) -- FIXME: playerLook(plr, nil)
        playerOnInput[plr] = nil
    end
    mobPlayerMap[plr] = nil
end

local function setExtraSpeed(mob, val)
    setPtrFloat(mob, 0x228, val)
end

playerOnGoObs = function(plr)
    local mob = mobPlayerMap[plr]
    playerOnInput[plr] = nil
    mobPlayerMap[plr] = nil
    if objectExists(mob) then
        removeMob(mob, plr)
    end
end

function spawnShaman(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 17 sec
 local skill2Ready = true -- 7 sec
 local skill3Ready = true -- 10 sec
 local mob = createObject("UrchinShaman", spx, spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 45) -- modify health
 setExtraSpeed(mob, -0.65) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob) -- fix
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 45
     MobArena.UrchinShaman.Attack(mob, x, y, pl)
    end
   elseif c == 47 then
    if (skill1Ready) then
     local mx, my = unitPos(mob)
     if mapTraceRay(mx, my, x, y, 1) then
      if distance(mx, my, x, y) < 280 then
       MobArena.UrchinShaman.Meteor(mob, x, y, pl)
       mt = fram + 15 -- animation
       skill1Ready = false
       setTimeout(function() skill1Ready = true end, utilSecToFrames(17, 1))
      else
       sendChat(plid, "It's too far away!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Can't cast there!", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Meteor: 17 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (unitCanAttack(mob, ta) and unitCanSeeUnit(mob, ta)) then
       if distance(mx, my, x, y) < 280 then
        MobArena.UrchinShaman.Confuse(mob, ta)
        mt = fram + 15 -- animation
        skill2Ready = false
        setTimeout(function() skill2Ready = true end, utilSecToFrames(7, 1))
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      else
       sendChat(plid, "Can't use that on allies!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Confuse: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Confuse: 7 seconds CD", servNetCode(mob), false)
    end
   elseif c == 48 then
    if (skill3Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (not unitCanAttack(mob, ta) and unitCanSeeUnit(mob, ta)) then
       if (distance(mx, my, x, y) < 250) then
        MobArena.UrchinShaman.HealRitual(mob, ta)
        mt = fram + 15 -- animation
        skill3Ready = false
        setTimeout(function() skill3Ready = true end, utilSecToFrames(10, 1))
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      else
       sendChat(plid, "Heal enemies? What?", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Healing Blast: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Healing Blast: 10 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnMechFlyer(spx, spy, plr)
 local mt
 local at = 0 -- attack timeout
 local skill1Ready = true -- 5 sec
 local skill2Ready = true -- 4 sec
 local skill3Ready = true -- 16 sec
 local skill1Shots = 0
 local channelFrame = 0
 local mob = createObject("FlyingGolem", spx, spy)
 local plid = playerInfo(plr).idx
 unitBecomePet(mob, plr)
 unitSetMaxHealth(mob, 50) -- >40 buff
 setExtraSpeed(mob, -0.65) -- must be equal to RUN_MULTIPLIER
 mobNoRunaway(mob)
 unitSetAgression(mob, 0)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  -- check channeling
  if skill1Shots > 0 then
    if not mobCanMove(mob) then skill1Shots = 0 end -- interrupt
    if channelFrame <= fram then
      channelFrame = fram + 9 -- 1.5 sec total
      skill1Shots = skill1Shots - 1
      local mx, my = unitPos(mob)
      soundMake(610, mx, my)
      unitSetLookAngle(mob, directGet(x, y, mx, my))
      -- shoot arrow
      local shot = createObject("GolemArrow", mx, my)
      arrowSetDamage(shot, math.random(7, 9)) -- increase damage
      unitSetParent(shot, pl) -- set owner
      unitSetLookAngle(shot, directGet(x, y, mx, my))
      local vx, vy
      vx = x - mx
      vy = y - my
      local vlen = math.sqrt(vx ^ 2 + vy ^ 2)
      vx = vx / vlen * 100
      vy = vy / vlen * 100
      if vx == vx and vy == vy then unitSpeed(shot, vx, vy)
      else unitDelete(shot) end
    end
    return true
  end
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 25
     MobArena.MechFlyer.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     unitActionPop(mob)
     buffCancel(mob, 23) -- ENCHANT_INVULNERABLE
     skill1Shots = 5
     channelFrame = fram + 9
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(5, 1))
    else
     sendChat(plid, "Rapid Fire: 5 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     MobArena.MechFlyer.TripleShot(mob, x, y, pl)
     
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(4, 1))
    else
     sendChat(plid, "Triple Shot: 4 seconds CD", servNetCode(mob), false)
    end
   elseif c == 48 then
    if (skill3Ready) then
     MobArena.MechFlyer.SelfRepair(mob)
     
     skill3Ready = false
     setTimeout(function() skill3Ready = true end, utilSecToFrames(16, 1))
    else
     sendChat(plid, "Self Repair: 16 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr, mob) end, 1)
 return mob
end

function spawnSkeleton(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 14 sec
 local skill1Active = false
 local regenFrames = 0
 local mob = createObject("SkeletonLord", spx, spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 60) -- modify health
 setExtraSpeed(mob, -0.5) -- modify speed
 mobNoAutoshield(mob)
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob
 
 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if skill1Active and regenFrames < fram then
    regenFrames = fram + 10
    unitAddHP(mob, 4) -- 12 hp/sec
    --local mx, my = unitPos(mob)
    --netRayFx(0x91, mx + 1, my + 1, mx - 1, my - 1)
  end
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     buffCancel(mob, 23) -- ENCHANT_INVULNERABLE
     if skill1Active then
        at = fram + 15
     else
        at = fram + 30
     end
     MobArena.Skeleton.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     skill1Active = true
     regenFrames = fram
     setTimeout(function() skill1Active = false end, utilSecToFrames(6, 1))
     soundMake(912, unitPos(mob))
     --local fx = createObject("StormCloud", unitPos(mob))
     --unitDecay(fx, 2)
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(14, 1))
    else
     sendChat(plid, "Unholy Power: 14 seconds CD", servNetCode(mob), false)
    end
   --[[elseif c == 49 then
    unitActionPop(mob)
    unitSetAction(mob, 21) -- ACTION_BLOCK_ATTACK
    ]]--
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnOgre(spx, spy, plr)
 local mt = 0 -- move timeout
 local at = 0 -- attack timeout
 local mr = 0 -- magic resist fx
 local hvx, hvy -- charge vector
 local skill1Ready = true -- 10 sec
 local skill2Ready = true -- 8 sec
 local chargeActive = false
 local chargeX, chargeY -- start pos
 local mob = createObject("OgreBrute", spx, spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 75) -- modify health
 setExtraSpeed(mob, -0.48) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob
 
 local cancelCharge, pushAndStunEnemies, ogreCollideHandler
 
 pushAndStunEnemies = function(p)
    if (unitIsMonster(p) and unitCanAttack(mob, p)) then
        local mx, my = unitPos(mob)
        local ex, ey = unitPos(p)
        local vx, vy
        vx = ex - mx
        vy = ey - my
        local vlen = math.sqrt(vx ^ 2 + vy ^ 2)
        vx = vx / vlen * 20
        vy = vy / vlen * 20
        if vx == vx and vy == vy then unitSpeed(p, vx, vy) end
        if isMagicVulnerable(p) then
            buffApply(p, 5, utilSecToFrames(1, 1))
            local power = distance(chargeX, chargeY, ex, ey)
            power = math.floor(power / 100) + 1
            unitDamage(p, power * 4)
        end -- ENCHANT_HELD, 1 sec
    end
 end
 
 ogreCollideHandler = function(ogre, collided)
    if chargeActive then
        if objectExists(collided) then
            if unitIsMonster(collided) then
                cancelCharge()
                unitActionPop(mob)
                local mx, my = unitPos(collided) -- get other creatures around
                unitGetAround(pushAndStunEnemies, mx - 30, my - 30, mx + 30, my + 30)
            end
        end
    end
    return false
 end
 
 cancelCharge = function()
    if objectExists(mob) then
        local uc = getPtrPtr(mob, 0x2EC)
        local status = getPtrInt(uc, 0x5A0)
        if bitAnd(status, 0x4000) == 0x4000 then
            status = bitXor(status, 0x4000)
            setPtrInt(uc, 0x5A0, status)
        end
        setExtraSpeed(mob, -0.48)
        chargeActive = false
        --unitActionPop(mob)
    end
 end

 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if (unitTestBuff(mob, 19) and mr < fram) then
    fxMagicResist(unitPos(mob))
    mr = fram + 2
  end
  
  if chargeActive then 
    if mt < fram then
     mt = fram + 15
     local px, py = unitPos(mob)
     px = px + hvx
     py = py + hvy
     if mapTraceRay(px, py, unitPos(mob)) then
      unitActionPop(mob)
      --unitSetLookAngle(mob, directGet(x, y, unitPos(mob)))
      --use ACTION_DODGE?
      setActionTargeted(mob, 7, px, py) -- ACTION_MOVE_TO
     else
      cancelCharge()
     end
    end
    return true -- block other actions
  end
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 40
     MobArena.Ogre.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     MobArena.Ogre.MagicResistance(mob)
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(14, 1))
    else
     sendChat(plid, "Magic Resistance: 14 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     buffCancel(mob, 23) -- ENCHANT_INVULNERABLE
     local uc = getPtrPtr(mob, 0x2EC)
     local status = getPtrInt(uc, 0x5A0)
     status = bitOr(status, 0x4000)
     setPtrInt(uc, 0x5A0, status)
     setTimeout(cancelCharge, 150)
     chargeActive = true
     local px, py = unitPos(mob)
     hvx = x - px
     hvy = y - py
     local vlen = math.sqrt(hvx ^ 2 + hvy ^ 2)
     hvx = hvx / vlen * 150
     hvy = hvy / vlen * 150
     chargeX, chargeY = unitPos(mob)
     setExtraSpeed(mob, 1)
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(10, 1))
    else
     sendChat(plid, "Charge: 10 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnCollide(mob, ogreCollideHandler)
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr, mob) end, 1)
 return mob
end

function spawnWasp(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local spawnFrame = 0 -- last wasp spawn from hive
 local spawnDelay = 150 -- delay between wasp spawning
 local skill1Ready = true -- 30 sec
 local activeNest = nil
 local activeWasps = 0
 local waspsList = {} -- TODO
 local mob = createObject("Wasp", spx, spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 25) -- buff health
 setExtraSpeed(mob, -0.65) -- must be equal to RUN_MULTIPLIER
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob
 
 local waspQueenDieHandler = function(killed, killer)
    removeMob(killed, plr)
    if objectExists(activeNest) then unitDamage(activeNest, 999) end
 end
 
 local waspWorkerDieHandler = function(killed, killer)
    activeWasps = activeWasps - 1
 end
 
 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local fram = getFrameCounter()

  if objectExists(activeNest) then
    local hx, hy = unitPos(activeNest)
    if fram > spawnFrame then
        if activeWasps < 3 then
            local w = createObject("Wasp", hx, hy)
            unitSetMaxHealth(w, 12) -- 15 hp default
            unitBecomePet(w, plr)
            unitSetAgression(w, 0.83)
            setTimeout(function() unitSetFollow(w, mob) end, 1) -- unitSetAction(w, 29) ACTION_RANDOM_WALK
            unitOnDie(w, waspWorkerDieHandler)
            soundMake(517, hx, hy)
            --sendChat(plid, "Bzzz...", servNetCode(w), false)
            activeWasps = activeWasps + 1
            spawnFrame = fram + spawnDelay
        end
    end
  end
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     MobArena.Wasp.Attack(mob, x, y)
     at = fram + 15
    end
   elseif c == 47 then
    if (skill1Ready) then
     local mx, my = unitPos(mob)
     if objectExists(activeNest) then unitDamage(activeNest, 999) end
     activeNest = MobArena.Wasp.CreateNest(mx, my, 80)
     unitSetParent(activeNest, mob)
     netPointFx(0x8A, mx, my)
     soundMake(835, mx, my)
     spawnFrame = fram + spawnDelay
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(30, 1))
    else
     sendChat(plid, "Build Nest: 30 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, waspQueenDieHandler) -- cleanup
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnZombie(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local deaths = 0
 local skill1Ready = true -- 10 sec
 local skill2Ready = true -- 10 sec
 local leashMaxDist = 200
 local leashDuration = 0 -- 150
 local activeTrap = nil -- PoisonGasTrap
 local leashed = nil -- leashed creature
 local mob = createObject("VileZombie", spx, spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 130) -- buff health
 setExtraSpeed(mob, 0.1) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob
 
 local setHandlers, zombieDieHandler
 setHandlers = function()
    unitOnDie(mob, zombieDieHandler) -- cleanup
    playerLook(plr, mob)
 end
 
 zombieDieHandler = function(killed, killer)
    leashed = nil -- drop leash
    if (deaths < 1) then
        deaths = deaths + 1
        --setPtrInt(uc, 0x1EC, 60) -- resurrection delay
        setTimeout(setHandlers, 0)
        return false
    end
    --local soul = createObject("ReleasedSoul", unitPos(mob))
    --unitSetLookAngle(soul, unitGetLookAngle(mob))
    if objectExists(activeTrap) then unitDelete(activeTrap) end
    removeMob(mob, plr)
    return false
 end
 
 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local fram = getFrameCounter()

  if objectExists(leashed) then
    local mx, my = unitPos(mob)
    local ex, ey = unitPos(leashed)
    netRayFx(0x95, mx, my, ex, ey)
    local dist = distance(mx, my, ex, ey)
    leashDuration = leashDuration + 1
    if not unitIsMonster(leashed) then 
        buffCancel(leashed, 4)
        leashed = nil
        leashDuration = 0
    elseif (dist > leashMaxDist or not unitCanSeeUnit(mob, leashed)) then
        if leashDuration > 265 then leashDuration = 265 end
        unitDamage(leashed, math.ceil(leashDuration * 0.15))
        buffCancel(leashed, 4)  -- ENCHANT_SLOWED
        leashed = nil
        leashDuration = 0
    elseif not unitTestBuff(leashed, 4) then
        buffApply(leashed, 4, utilSecToFrames(1, 1))
    end
  end
  
  if not mobCanMove(mob) or not unitIsMonster(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     MobArena.Zombie.Attack(mob, x, y)
     at = fram + 40
    end
   elseif c == 47 then
    if (skill1Ready) then
     buffCancel(mob, 23) -- ENCHANT_INVULNERABLE
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (unitCanAttack(mob, ta) and unitCanSeeUnit(mob, ta)) then
       if (distance(mx, my, x, y) < leashMaxDist) then
        if isMagicVulnerable(ta) then
            leashed = ta
        end
        buffApply(ta, 4, utilSecToFrames(1, 1)) -- ENCHANT_SLOWED
        skill1Ready = false
        setTimeout(function() skill1Ready = true end, utilSecToFrames(10, 1))
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      else
       sendChat(plid, "Can't use that on allies!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Leash: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Leash: 10 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     if objectExists(activeTrap) then unitDelete(activeTrap) end
     activeTrap = MobArena.Zombie.PlaceTrap(mob, pl)
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(10, 1))
    else
     sendChat(plid, "Gas Trap: 10 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 setTimeout(setHandlers, 1)
 return mob
end

function spawnDryad(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 11 sec
 local skill2Ready = true -- 6 sec
 local skill3Ready = true -- 10 sec
 local illusion = nil
 local mob = createObject("WizardGreen",spx,spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 40) -- modify health
 setExtraSpeed(mob, -0.6) -- modify speed
 mobSetSpell(mob, 4, 0) -- forbid SPELL_BLINK
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob) -- fix
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob
 
 local illusionMove = function()
    local mx, my = playerMouse(plr)
    local x, y = unitPos(illusion)
    local vx, vy
    vx = x - mx
    vy = y - my
    x = x + vx
    y = y + vy
    if mapTraceRay(x, y, unitPos(illusion)) then
        setActionTargeted(illusion, 7, x, y)
    else
        unitSetAction(illusion, 29) -- ACTION_RANDOM_WALK
    end -- if illusion unable go that way, let it randomly walk around
    unitNoCollide(illusion, true)
    unitDecay(illusion, utilSecToFrames(5, 1))
 end

 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 30
     MobArena.Dryad.Attack(mob, x, y, pl)
    end
   elseif c == 47 then
    if (skill1Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (unitCanAttack(mob, ta) and unitCanSeeUnit(mob, ta)) then
       if (distance(mx, my, x, y) < 320) then
        MobArena.Dryad.NWEffect(mob, ta)
        mt = fram + 15
        skill1Ready = false
        setTimeout(function() skill1Ready = true end, utilSecToFrames(10, 1))
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      else
       sendChat(plid, "Can't use that on allies!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Wrath of Nature: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Wrath of Nature: 10 seconds CD", servNetCode(mob), false)
    end
   elseif c == 48 then
    if (skill3Ready) then
     illusion = createObject("WizardGreen", unitPos(mob))
     unitNoCollide(illusion, false)
     unitSetMaxHealth(illusion, 0)
     unitBecomePet(illusion, pl)
     unitSetAgression(illusion, 0)
     mobSetSpell(illusion, 4, 0)
     mobNoRunaway(illusion)
     setTimeout(illusionMove, 2)
     soundMake(121, unitPos(mob))
     skill3Ready = false
     setTimeout(function() skill3Ready = true end, utilSecToFrames(11, 1))
    else
     sendChat(plid, "Illusion: 11 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (unitCanAttack(mob, ta) and unitCanSeeUnit(mob, ta)) then
       if (distance(mx, my, x, y) < 280) then
        MobArena.Dryad.ApplyFear(mob, ta)
        mt = fram + 15
        skill2Ready = false
        setTimeout(function() skill2Ready = true end, utilSecToFrames(6, 1))
        sendChat(plid, "Run as fast as you can!", servNetCode(mob), false)
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      else
       sendChat(plid, "Can't use that on allies!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Cause Fear: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Cause Fear: 6 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnScorpion(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local ct = 0 -- chitin grow timeout
 local mr = 0 -- magic resist fx
 local skill1Ready = true -- 10 sec
 local chitinLayers = 0
 local layersGUI = {}
 local mob = createObject('Scorpion',spx,spy)
 unitSetMaxHealth(mob, 60) -- modify health
 setExtraSpeed(mob, -0.65) -- modify speed
 local plid = playerInfo(plr).idx
 unitBecomePet(mob,plr)
 unitSetAgression(mob,0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob
 
 local addChitinLayer
 addChitinLayer = function()
    if not objectExists(mob) then
        for i = 1, #layersGUI do
            local orb = layersGUI[i]
            if objectExists(orb) then unitDelete(orb) end
        end
        return -- stop cycle
    elseif (chitinLayers < 3) then
        chitinLayers = chitinLayers + 1
        local orb = createObject("CharmOrb", unitPos(mob))
        layersGUI[chitinLayers] = orb
    end
    unitAddHP(mob, 5) -- heal
    setTimeout(addChitinLayer, utilSecToFrames(3, 1)) -- grow chitin every 3 seconds
 end
 
 local removeChitinLayer = function()
    if (chitinLayers > 0) then
        unitDelete(layersGUI[chitinLayers])
        layersGUI[chitinLayers] = nil
        chitinLayers = chitinLayers - 1
    end
 end
 
 local scorpionDamageHandler = function(damaged, parent, damager, value, typ)
    if (chitinLayers > 0 and value > 1) then
        removeChitinLayer()
        value = math.ceil(value / 10)
    end
    return false, value -- reduced damage
 end

 addChitinLayer() -- one at start
 
 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local mx, my = unitPos(mob)
  local fram = getFrameCounter()
  
  for i = 1, #layersGUI do
    local orb = layersGUI[i]
    local nx = mx + 7 * i - 16
    local ny = my - 20
    if objectExists(orb) then unitMove(orb, nx, ny) end
  end
  
  if (unitTestBuff(mob, 19) and mr < fram) then
    fxMagicResist(unitPos(mob))
    mr = fram + 2
  end
  
  if not mobCanMove(mob) then return true end
  if c == 1 then
   if mt and mt < fram and at < fram then 
    unitActionPop(mob)
    mobCheckFrustrated(mob)
    mt = fram + 1
   end
  elseif c == 2 then -- move to 
   if (not mt) or mt < fram then
    mt = fram + 10
    MobArena_CreatureMoveDefault(mob, x, y)
   end
  elseif c == 6 then -- attack
   if at < fram then
    at = fram + 50
    MobArena.Scorpion.Attack(mob, x, y)
   end
  end
 return true
 end
 
 unitOnDamage(mob, scorpionDamageHandler)
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr, mob) end,1)
 return mob
end

function spawnGargoyle(spx, spy, plr)
 local mt
 local at = 0 -- attack timeout
 local skill1Ready = true -- 4 sec
 local skill2Ready = true -- 6 sec
 local mob = createObject('EvilCherub',spx,spy)
 local plid = playerInfo(plr).idx
 unitNoPoisonResist(mob)
 setExtraSpeed(mob, -0.6) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 25
     MobArena.Gargoyle.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     MobArena.Gargoyle.DeathShot(mob, x, y)
     
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(4, 1))
    else
     sendChat(plid, "Death Shot: 4 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     MobArena.Gargoyle.PowerShot(mob, x, y)
     
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(6, 1))
    else
     sendChat(plid, "Power Shot: 6 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr,mob) end,1)
 return mob
end

function spawnArchmage(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 10 sec
 local skill2Ready = true -- 12 sec
 local skill3Ready = true -- 8 sec
 local controlled = nil
 local mob = createObject('WizardWhite',spx,spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 40) -- modify health
 setExtraSpeed(mob, -0.60) -- real value should be -0.65
 mobSetSpell(mob, 4, 0) -- forbid SPELL_BLINK
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob) -- fix
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x, y = playerMouse(pl)
  local fram = getFrameCounter()
  
  -- check channeling
  if objectExists(controlled) then
   local mx, my = unitPos(mob)
   if (mapTraceRay(mx, my, x, y, 1) and distance(mx, my, x, y) < 400) then
    unitMove(controlled, x, y)
    unitSetLookAngle(mob, directGet(x, y, mx, my))
    netRayFx(0x91, x, y, mx, my)
   end
   c = 1 -- forbid other actions
  end
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 30
     MobArena.Archmage.Attack(mob, x, y, pl)
    end
   elseif c == 47 then
    if (skill1Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (not unitCanAttack(mob, ta)) and unitCanSeeUnit(mob, ta) then
       MobArena.Archmage.ForceField(mob, ta)
       mt = fram + 15 -- wait for animation
       skill1Ready = false
       setTimeout(function() skill1Ready = true end, utilSecToFrames(10, 1))
      else
       sendChat(plid, "Can't cast that on enemies!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Force Field: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Force Field: 10 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     MobArena.Archmage.Restoration(mob)
     mt = fram + 15 -- wait for animation
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(12, 1))
    else
     sendChat(plid, "Restoration: 12 seconds CD", servNetCode(mob), false)
    end
   elseif c == 48 then
    if (skill3Ready) then
     local mx, my = unitPos(mob)
     if (mapTraceRay(mx, my, x, y)) then
      controlled = MobArena.Archmage.Immolation(mob, x, y)
      mt = fram + 15 -- wait for animation
      skill3Ready = false
      setTimeout(function() skill3Ready = true end, utilSecToFrames(8, 1))
     else
      sendChat(plid, "Can't cast there!", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Immolation: 8 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnNecromancer(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 8 sec
 local skill2Ready = true -- 14 sec
 local skill3Ready = true -- 11 sec
 local mob = createObject('Necromancer', spx, spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 50) -- modify health
 setExtraSpeed(mob, -0.8) -- modify speed
 unitNoPoisonResist(mob)
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobNoRunaway(mob) -- fix
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 24
     MobArena.Necromancer.Attack(mob, x, y, pl)
    end
   elseif c == 47 then
    if (skill1Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (unitCanAttack(mob, ta) and unitCanSeeUnit(mob, ta)) then
       if distance(mx, my, x, y) < 375 then
        MobArena.Necromancer.ChillTouch(mob, ta)
        mt = fram + 25 -- wait for animation
        skill1Ready = false
        setTimeout(function() skill1Ready = true end, utilSecToFrames(8, 1))
        sendChat(plid, "Very, very cold!", servNetCode(mob), false)
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      else
       sendChat(plid, "Can't use that on allies!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Chill Touch: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Chill Touch: 8 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     MobArena.Necromancer.DeepFreeze(mob)
     mt = fram + 25 -- wait for animation
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(14, 1))
    else
     sendChat(plid, "Deep Freeze: 14 seconds CD", servNetCode(mob), false)
    end
   elseif c == 48 then
    if (skill3Ready) then
     local mx, my = unitPos(mob)
     if mapTraceRay(mx, my, x, y) then
      if distance(mx, my, x, y) < 200 then
       MobArena.Necromancer.RaiseZombie(mob, x, y, pl)
       mt = fram + 25 -- wait for animation
       skill3Ready = false
       setTimeout(function() skill3Ready = true end, utilSecToFrames(11, 1))
      else
       sendChat(plid, "It's too far away!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Can't cast there!", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Raise Zombie: 11 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnTroll(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 4 sec
 local skill2Active = false -- active skill
 local mob = createObject('Troll', spx, spy)
 local plid = playerInfo(plr).idx
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  -- check second active skill
  if (skill2Active and math.mod(getFrameCounter(), 20) == 0) then
    -- spawn toxic cloud every 20 frames then
    MobArena.Troll.Stink(mob, pl)
  end
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 60
     MobArena.Troll.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     MobArena.Troll.Harpoon(mob, x, y)
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(8, 1))
    else
     sendChat(plid, "Harpoon: 8 seconds CD", servNetCode(mob), false)
    end
   elseif c == 7 then
    skill2Active = not skill2Active
    if (skill2Active) then soundMake(644, unitPos(mob)) sendChat(plid, "Ouch...", servNetCode(mob), false) 
    else sendChat(plid, "I feel better now...", servNetCode(mob), false) end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnWolf(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 6 sec
 local skill2Ready = true -- 7 sec
 local companion = nil -- 3 skill
 local mob = createObject('WhiteWolf', spx, spy)
 local plid = playerInfo(plr).idx
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 local wolfDamageHandler = function(damaged, parent, damager, value, typ)
    if (value > 1 and objectExists(companion)) then
        value = math.ceil(value / 2)
        unitDamage(companion, value)
    end
    return false, value -- reduced damage
 end
 
 local wolfDieHandler = function(killed, killer)
    removeMob(killed, plr) 
    if (objectExists(companion)) then unitDamage(companion, 100) end
 end
 
 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 30
     MobArena.Wolf.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     buffApply(mob, 13, utilSecToFrames(4, 1)) -- ENCHANT_VAMPIRISM, 4 sec
     buffSetPower(mob, 13, 5) -- 50%
     if (objectExists(companion)) then
      buffApply(companion, 13, utilSecToFrames(4, 1))
      buffSetPower(companion, 13, 5) -- 50% 
     end -- also buff companion
     sendChat(plid, "I hunger!", servNetCode(mob), false)
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(6, 1))
    else
     sendChat(plid, "Hunger: 6 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     buffApply(mob, 0, utilSecToFrames(4, 1)) -- ENCHANT_INVISIBLE, 4 sec
     if (objectExists(companion)) then buffApply(companion, 0, utilSecToFrames(4, 1)) end -- also buff companion
     sendChat(plid, "Stealthy!", servNetCode(mob), false)
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(7, 1))
    else
     sendChat(plid, "Stealth: 7 seconds CD", servNetCode(mob), false)
    end
   elseif c == 48 then
    if (not objectExists(companion)) then
     companion = createObject("Wolf", unitPos(mob))
     unitBecomePet(companion, plr)
     setTimeout(function() unitSetFollow(companion, mob) unitSetAgression(companion, 0.83) end, 1)
     unitOnDie(companion, function(killed, killer) unitDecay(killed, 20) end)
     sendChat(plid, "Hello there!", servNetCode(companion), false)
    else
     sendChat(plid, "Can't summon more!", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDamage(mob, wolfDamageHandler)
 unitOnDie(mob, wolfDieHandler) -- cleanup, also remove companion
 setTimeout(function() playerLook(plr,mob) end, 1)
 return mob
end

function spawnSpider(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skill1Ready = true -- 6 sec
 local skill2Ready = true -- 15 sec
 local mob = createObject('SpittingSpider', spx, spy)
 local plid = playerInfo(plr).idx
 setExtraSpeed(mob, -0.7) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 30
     MobArena.Spider.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (unitCanAttack(mob, ta) and unitCanSeeUnit(mob, ta)) then
       if (distance(mx, my, x, y) < 220) then
        MobArena.Spider.Poison(mob, ta)
        
        skill1Ready = false
        setTimeout(function() skill1Ready = true end, utilSecToFrames(6, 1))
        sendChat(plid, "Poison!", servNetCode(mob), false)
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      else
       sendChat(plid, "Can't use that on allies!", servNetCode(mob), false)
      end
     else
      sendChat(plid, "Poison: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Poison: 6 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     MobArena.Spider.Spiderlings(mob, pl)
     
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(15, 1))
     sendChat(plid, "Spiderlings!", servNetCode(mob), false)
    else
     sendChat(plid, "Spiderlings: 15 seconds CD", servNetCode(mob), false)
    end
   elseif c == 7 then -- alternate attack
    if (not at) or at < fram then
     at = fram + 26
     unitSetLookAngle(mob, directGet(x, y, unitPos(mob)))
     MobArena.Spider.ShootWeb(mob, pl)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr, mob) end, 1)
 return mob
end

function spawnImp(spx, spy, plr)
 local mt
 local at = 0 -- attack timeout
 local skill1Ready = true -- 20 sec
 local skill2Ready = true -- 8 sec
 local clones = { }
 local mob = createObject('Imp', spx, spy)
 local plid = playerInfo(plr).idx
 setExtraSpeed(mob, -0.65) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 30
     MobArena.Imp.Attack(mob, x, y)
     MobArena.Imp.ClonesAttack(x, y, clones)
    end
   elseif c == 47 then
    if (skill1Ready) then
     clones = MobArena.Imp.Clone(mob, pl)
     
     sendChat(plid, "So many!", servNetCode(mob), false)
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(20, 1))
    else
     sendChat(plid, "Clone: 20 seconds CD", servNetCode(mob), false)
    end
   elseif c == 49 then
    if (skill2Ready) then
     MobArena.Imp.Haste(mob)
     
     sendChat(plid, "Faster than wind!", servNetCode(mob), false)
     skill2Ready = false
     setTimeout(function() skill2Ready = true end, utilSecToFrames(8, 1))
    else
     sendChat(plid, "Haste: 8 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr, mob) end, 1)
 return mob
end

function spawnBear(spx, spy, plr)
 local mt
 local at = 0 -- attack timeout
 local skill1Ready = true -- 8 sec
 local regenerateCD = 0 -- 4 hp/sec
 local mob = createObject('Bear',spx,spy)
 local plid = playerInfo(plr).idx
 unitSetMaxHealth(mob, 110) -- modify health
 setExtraSpeed(mob, -0.25) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob,0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  -- extra regeneration
  if regenerateCD < fram then
    regenerateCD = fram + 30
    if unitLastDamageDiff(mob) > 60 then
        regenerateCD = fram + 30
        unitAddHP(mob, 4)
    end -- regen only if Bear wasn't attacked last 2 seconds (30x2)
  end
  
  if not mobCanMove(mob) then return true end
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 48
     MobArena.Bear.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill1Ready) then
     MobArena.Bear.Bash(mob)
     sendChat(plid, "Strike!", servNetCode(mob), false)
     skill1Ready = false
     setTimeout(function() skill1Ready = true end, utilSecToFrames(8, 1))
    else
     sendChat(plid, "Bash: 8 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr, mob) end,1)
 return mob
end

function spawnShade(spx, spy, plr)
 local mt -- move timeout
 local at = 0 -- attack timeout
 local skillCD1 = getFrameCounter() + 60 -- 2 sec
 local skill2Ready = true -- 5 sec
 local mob = createObject('Shade', spx, spy)
 unitSetMaxHealth(mob, 60) -- modify health
 local plid = playerInfo(plr).idx
 setExtraSpeed(mob, -0.65) -- modify speed
 unitBecomePet(mob, plr)
 unitSetAgression(mob, 0)
 mobNoRunaway(mob)
 buffApply(mob, 23, utilSecToFrames(4, 1)) -- ENCHANT_INVULNERABLE
 mobPlayerMap[plr] = mob

 playerOnInput[plr] = function (pl,c,targ)
  local x,y = playerMouse(pl)
  local fram = getFrameCounter()
  
  -- check passive skill
  if (fram > skillCD1) then -- make invisible
   if (not unitTestBuff(mob,0)) then
    buffApply(mob,0,0) -- permanently invisible
    skillCD1 = fram + 60
   end
  end
  
  if not mobCanMove(mob) then return true end
  
   if c == 1 then
    if mt and mt < fram and at < fram then 
     unitActionPop(mob)
     mobCheckFrustrated(mob)
     mt = fram + 1
    end
   elseif c == 2 then -- move to 
    if (not mt) or mt < fram then
     mt = fram + 10
     MobArena_CreatureMoveDefault(mob, x, y)
    end
   elseif c == 6 then -- attack
    if at < fram then
     at = fram + 20
     skillCD1 = fram + 60
     MobArena.Shade.Attack(mob, x, y)
    end
   elseif c == 47 then
    if (skill2Ready) then
     local ta = atPlayerMouse(pl)
     if (ta) then
      local mx, my = unitPos(mob)
      if (unitCanSeeUnit(mob, ta) and mob ~= ta) then
       if (distance(mx, my, x, y) < 360) then
        MobArena.Shade.Jump(mob, ta)
       
        skill2Ready = false
        setTimeout(function() skill2Ready = true end, utilSecToFrames(5, 1))
       else
        sendChat(plid, "It's too far away!", servNetCode(mob), false)
       end
      end
     else
      sendChat(plid, "Jump: No target", servNetCode(mob), false)
     end
    else
     sendChat(plid, "Jump: 5 seconds CD", servNetCode(mob), false)
    end
   end
 return true
 end
 
 unitOnDie(mob, function (killed, killer) removeMob(killed, plr) end) -- cleanup
 setTimeout(function() playerLook(plr, mob) end, 1)
 return mob
end